#/bin/bash

#ssh root@192.168.3.148
#kopieren nach /etc/tuxbox/config/
#chmod 755 /etc/tuxbox/config/archive.sh
#starten mit /etc/tuxbox/config/archive.sh

#eintragen in
#vi /etc/cron/crontabs/root
#crontab -e (alternativ zu obigem befehl)
#Täglich um 11 Uhr auführen
#0 11 * * * /etc/tuxbox/config/archive.sh
#Alle 30 Minuten auführen
#*/30 * * * * /etc/tuxbox/config/archive.sh
#chmod 744 /etc/cron/crontabs/root (vermutlich notwendig)
#/etc/init.d/busybox-cron start
#/etc/init.d/busybox-cron restart
#update-rc.d busybox-cron defaults

################################################################

source_root="media"
source_volume="hdd"
source_folder="movie"

destination_root="media"
destination_volume="hdd1"
destination_folder="archive"

source_freespace_minimum="400000000" #kB -> entspricht 400GB

extension=".ts"

################################################################

#Source Volume und Folder vorhanden?
if [[ ! -e "/$source_root/$source_volume/$source_folder" ]]
then
    echo " existiert nicht - exit"
    exit
fi

source_freespace=`df -k "/$source_root/$source_volume" | awk '/[0-9]%/{print $4}'`
#echo "source_freespace: $source_freespace kB"

#Source Volume - Genug Speicherplatz frei?
if [ "$source_freespace" -gt "$source_freespace_minimum" ]
then
    if [ "$source_freespace" -ge "1000" ]
    then
        #source_freespace_echo="${source_freespace:0:${#source_freespace}-3} MB"
        source_freespace_echo="$(($source_freespace / 1024)) MB"
    else
        source_freespace_echo="$source_freespace kB"
    fi

    if [ "$source_freespace" -ge "1000000" ]
    then
        #source_freespace_echo="${source_freespace:0:${#source_freespace}-6} GB"
        source_freespace_echo="$(($source_freespace / 1048576)) GB"
    fi
    echo "$source_root/$source_volume hat noch genug freien Speicherplatz ($source_freespace_echo) - exit"
    exit
fi

#Zu kopierende Datei/en vorhanden?
if [[ `ls "/$source_root/$source_volume/$source_folder" | grep -c "\$extension"` = 0 ]]
then
    echo "Keine zu kopierernde Datei vorhanden - exit"
    exit
fi

#Dateien in Source nacheinander durchgehen
for file in /$source_root/$source_volume/$source_folder/*$extension
do
    #echo "$file"
    file_without_folder=${file##*\/}
    #echo "file_without_folder: $file_without_folder"

    file_size=`du -k "$file" | cut -f1`
    #echo "file_size: $file_size"

    #Ist die Datei nach 1 Sekunde immer noch gleich groß? -> Aufnahme sollte abgeschlossen sein und Datei kann archiviert werden
    sleep 1
    file_size_update=`du -k "$file" | cut -f1`

    #Wenn Dateigrößen nach 1 Sekunde noch identisch -> Aufnahme abgeschlossen
    if [ "$file_size" = "$file_size_update" ]
    then
        #Destination Volume vorhanden?
        if [[ ! -e "/$destination_root/$destination_volume" ]]
        then
            echo "/$destination_root/$destination_volume existiert nicht - exit"
            exit
        fi

        #Destination Folder noch nicht vorhanden? In diesem Fall wird es versucht anzulegen
        if [[ ! -e "/$destination_root/$destination_volume/$destination_folder" ]]
        then
            mkdir "/$destination_root/$destination_volume/$destination_folder"
            sleep 1
        fi

        #Destination Folder jetzt vorhanden?
        if [[ ! -e "/$destination_root/$destination_volume/$destination_folder" ]]
        then
            echo "/$destination_root/$destination_volume/$destination_folder konnte nicht erstellt werden - exit"
            exit
        fi

        destination_freespace=`df -k "/$destination_root/$destination_volume" | awk '/[0-9]%/{print $4}'`

        #Wenn genug Platz auf Destination bzw. Source entspricht Destination
        if [[ "$(($destination_freespace-100000))" -gt "$file_size" || "$destination_root/$destination_volume" = "$source_root/$source_volume" ]]
        then
            file_without_extension=${file%$extension*}
            #echo "$file_without_extension"
        
            file_without_folder_without_extension=${file_without_folder%$extension*}
            #echo "$file_without_folder_without_extension"

            echo "$file_without_folder wird archiviert"

            mv "$file_without_extension$extension" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension$extension"

            #Sofern gleichlautende .ts.meta Datei vorhanden -> Ebenfalls verschieben
            if [[ -e "//$file_without_extension.ts.meta" ]]
            then
                mv "$file_without_extension.ts.meta" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension.ts.meta"
            fi

            if [[ -e "//$file_without_extension.ts.sc" ]]
            then
                mv "$file_without_extension.ts.sc" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension.ts.sc"
            fi

            if [[ -e "//$file_without_extension.ts.cuts" ]]
            then
                mv "$file_without_extension.ts.cuts" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension.ts.cuts"
            fi

            if [[ -e "//$file_without_extension.ts.ap" ]]
            then
                mv "$file_without_extension.ts.ap" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension.ts.ap"
            fi

            if [[ -e "//$file_without_extension.eit" ]]
            then
                mv "$file_without_extension.eit" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension.eit"
            fi

            if [[ -e "//$file_without_extension""check_.txt" ]]
            then
                mv "$file_without_extension""check_.txt" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension""check_.txt"
            fi

            if [[ -e "//$file_without_extension""_check.log" ]]
            then
                mv "$file_without_extension""_check.log" "/$destination_root/$destination_volume/$destination_folder/$file_without_folder_without_extension""_check.log"
            fi
        else
            echo "$file_without_folder kann nicht kopiert werden, da nicht genug Speicherplatz vorhanden"
        fi
    else
        echo "$file_without_folder skipped - Aufnahme läuft noch"
    fi
done